"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  Autocomplete: () => autocomplete_default,
  Combobox: () => combobox_default,
  SearchSelect: () => searchSelect_default,
  Select: () => select_default,
  TreeSelect: () => treeSelect_default,
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);

// src/select.tsx
var import_classnames = __toESM(require("classnames"));
var import_react = __toESM(require("react"));
var import_react2 = require("@headlessui/react");
var import_solid = require("@heroicons/react/20/solid");
function Select({
  className,
  options,
  selectedOption,
  selectedOptions,
  onChange,
  multiple,
  placeholder,
  isLoading,
  filter,
  resetButton = true
}) {
  const selectedValue = multiple ? selectedOptions : selectedOption;
  const selectedLabel = multiple ? selectedOptions?.map((x) => x.label).join(", ") : selectedOption?.label;
  return /* @__PURE__ */ import_react.default.createElement(
    import_react2.Listbox,
    {
      value: selectedValue || null,
      onChange,
      multiple,
      as: "div",
      className: (0, import_classnames.default)("relative", className)
    },
    /* @__PURE__ */ import_react.default.createElement(
      import_react2.Listbox.Button,
      {
        className: (0, import_classnames.default)(
          "form-input relative w-full cursor-default pl-3 pr-10 text-left",
          filter ? "form-input-filter" : ""
        )
      },
      /* @__PURE__ */ import_react.default.createElement(
        "span",
        {
          title: selectedLabel,
          className: (0, import_classnames.default)(
            "block truncate",
            selectedLabel ? "" : "text-secondary-500"
          )
        },
        selectedLabel || placeholder
      ),
      (!resetButton || !selectedLabel) && /* @__PURE__ */ import_react.default.createElement("span", { className: "pointer-events-none absolute inset-y-0 right-2 flex items-center" }, /* @__PURE__ */ import_react.default.createElement(import_solid.ChevronDownIcon, { className: "form-input-icon h-5 w-5", "aria-hidden": "true" }))
    ),
    resetButton && selectedLabel && /* @__PURE__ */ import_react.default.createElement(
      "button",
      {
        type: "button",
        className: "form-input-reset absolute z-10 right-2.5 inset-y-0 my-auto h-5 px-0.5",
        onClick: () => {
          if (multiple) {
            onChange([]);
          } else {
            onChange(null);
          }
        }
      },
      /* @__PURE__ */ import_react.default.createElement(import_solid.XMarkIcon, { className: "h-4 w-4", "aria-hidden": "true" })
    ),
    /* @__PURE__ */ import_react.default.createElement(
      import_react2.Transition,
      {
        as: import_react.Fragment,
        leave: "transition ease-in duration-100",
        leaveFrom: "opacity-100",
        leaveTo: "opacity-0"
      },
      /* @__PURE__ */ import_react.default.createElement(import_react2.Listbox.Options, { className: "form-input-popup absolute z-40 mt-1 w-full bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none text-sm" }, options.length === 0 || isLoading ? /* @__PURE__ */ import_react.default.createElement("div", { className: "relative cursor-default select-none py-2 px-4 text-secondary-700" }, isLoading ? "Loading..." : "No options") : /* @__PURE__ */ import_react.default.createElement("div", { className: "overflow-auto max-h-60" }, options.map((option) => /* @__PURE__ */ import_react.default.createElement(
        import_react2.Listbox.Option,
        {
          key: option.label,
          className: ({ active }) => `relative cursor-default select-none py-2 pl-10 pr-4 text-secondary-800 ${active ? "bg-primary-100" : ""}`,
          value: option
        },
        ({ selected }) => /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement(
          "span",
          {
            title: option.label,
            className: `block truncate ${selected && selectedValue ? "font-medium text-secondary-900" : "font-normal"}`
          },
          option.label
        ), selected && selectedValue ? /* @__PURE__ */ import_react.default.createElement("span", { className: "absolute inset-y-0 left-0 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ import_react.default.createElement(import_solid.CheckIcon, { className: "h-5 w-5", "aria-hidden": "true" })) : null)
      ))))
    )
  );
}
var select_default = (0, import_react.memo)(Select);

// src/searchSelect.tsx
var import_classnames2 = __toESM(require("classnames"));
var import_react3 = __toESM(require("react"));
var import_react4 = require("@headlessui/react");
var import_solid2 = require("@heroicons/react/20/solid");
function SearchSelect({
  className,
  options,
  selectedOption,
  selectedOptions,
  onChange,
  multiple,
  placeholder,
  isLoading,
  filter,
  resetButton = true
}) {
  const [searchQuery, setSearchQuery] = (0, import_react3.useState)("");
  const selectedValue = multiple ? selectedOptions : selectedOption;
  const selectedLabel = multiple ? selectedOptions?.map((x) => x.label).join(", ") : selectedOption?.label;
  const searchString = searchQuery.toLowerCase().replace(/\s+/g, "");
  const currentOptions = searchQuery === "" ? options : options.filter(
    (x) => x.label.toLowerCase().replace(/\s+/g, "").includes(searchString)
  );
  return /* @__PURE__ */ import_react3.default.createElement(
    import_react4.Combobox,
    {
      value: selectedValue || null,
      onChange,
      multiple,
      nullable: true,
      as: "div",
      className: (0, import_classnames2.default)("relative", className)
    },
    /* @__PURE__ */ import_react3.default.createElement(import_react4.Combobox.Button, { as: "div" }, /* @__PURE__ */ import_react3.default.createElement(
      "button",
      {
        type: "button",
        className: (0, import_classnames2.default)(
          "form-input relative w-full cursor-default pl-3 pr-10 text-left",
          filter ? "form-input-filter" : ""
        )
      },
      /* @__PURE__ */ import_react3.default.createElement(
        "span",
        {
          title: selectedLabel,
          className: (0, import_classnames2.default)(
            "block truncate",
            selectedLabel ? "" : "text-secondary-500"
          )
        },
        selectedLabel || placeholder
      ),
      (!resetButton || !selectedLabel) && /* @__PURE__ */ import_react3.default.createElement("span", { className: "pointer-events-none absolute inset-y-0 right-0 flex items-center pr-2" }, /* @__PURE__ */ import_react3.default.createElement(import_solid2.ChevronDownIcon, { className: "form-input-icon h-5 w-5", "aria-hidden": "true" }))
    )),
    resetButton && selectedLabel && /* @__PURE__ */ import_react3.default.createElement(
      "button",
      {
        type: "button",
        className: "form-input-reset absolute z-10 right-2.5 inset-y-0 my-auto h-5 px-0.5",
        onClick: () => {
          if (multiple) {
            onChange([]);
          } else {
            onChange(null);
          }
        }
      },
      /* @__PURE__ */ import_react3.default.createElement(import_solid2.XMarkIcon, { className: "h-4 w-4", "aria-hidden": "true" })
    ),
    /* @__PURE__ */ import_react3.default.createElement(
      import_react4.Transition,
      {
        as: import_react3.Fragment,
        leave: "transition ease-in duration-100",
        leaveFrom: "opacity-100",
        leaveTo: "opacity-0",
        afterLeave: () => {
          setSearchQuery("");
        }
      },
      /* @__PURE__ */ import_react3.default.createElement(import_react4.Combobox.Options, { className: "form-input-popup absolute z-40 mt-1 w-full bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none text-sm" }, !isLoading && /* @__PURE__ */ import_react3.default.createElement("div", { className: "relative" }, /* @__PURE__ */ import_react3.default.createElement(
        import_solid2.MagnifyingGlassIcon,
        {
          className: "pointer-events-none absolute top-3.5 left-4 h-5 w-5 text-secondary-400",
          "aria-hidden": "true"
        }
      ), /* @__PURE__ */ import_react3.default.createElement(
        import_react4.Combobox.Input,
        {
          type: "search",
          placeholder: "Search...",
          className: "h-12 w-full bottom-0 border-transparent pl-11 pr-4 text-secondary-800 placeholder-secondary-400 text-sm focus:border-none focus:outline-none focus:ring-0 focus:shadow-none",
          displayValue: () => searchQuery,
          onChange: (event) => {
            setSearchQuery(event.target.value);
          }
        }
      )), currentOptions.length === 0 || isLoading ? /* @__PURE__ */ import_react3.default.createElement("div", { className: "relative cursor-default select-none py-2 px-4 text-secondary-700" }, isLoading ? "Loading..." : "No options") : /* @__PURE__ */ import_react3.default.createElement("div", { className: "overflow-auto max-h-60" }, currentOptions.map((option) => /* @__PURE__ */ import_react3.default.createElement(
        import_react4.Combobox.Option,
        {
          key: option.label,
          className: ({ active }) => `relative cursor-default select-none py-2 pl-10 pr-4 text-secondary-800 ${active ? "bg-primary-100" : ""}`,
          value: option
        },
        ({ selected }) => /* @__PURE__ */ import_react3.default.createElement(import_react3.default.Fragment, null, /* @__PURE__ */ import_react3.default.createElement(
          "span",
          {
            title: option.label,
            className: `block truncate ${selected && selectedValue ? "font-medium text-secondary-900" : "font-normal"}`
          },
          option.label
        ), selected && selectedValue ? /* @__PURE__ */ import_react3.default.createElement("span", { className: "absolute inset-y-0 left-0 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ import_react3.default.createElement(import_solid2.CheckIcon, { className: "h-5 w-5", "aria-hidden": "true" })) : null)
      ))))
    )
  );
}
var searchSelect_default = (0, import_react3.memo)(SearchSelect);

// src/combobox.tsx
var import_react5 = __toESM(require("react"));
function Combobox2(props) {
  if (props.options.length > 6) {
    return /* @__PURE__ */ import_react5.default.createElement(searchSelect_default, { ...props });
  }
  return /* @__PURE__ */ import_react5.default.createElement(select_default, { ...props });
}
var combobox_default = (0, import_react5.memo)(Combobox2);

// src/autocomplete.tsx
var import_classnames3 = __toESM(require("classnames"));
var import_react6 = __toESM(require("react"));
var import_react7 = require("@headlessui/react");
var import_solid3 = require("@heroicons/react/20/solid");
function Autocomplete({
  className,
  options,
  selectedOption,
  onChange,
  placeholder,
  isLoading,
  filter,
  searchQuery,
  onSearch,
  minQueryLength = 2,
  resetButton = true
}) {
  const selectedValue = selectedOption;
  const selectedLabel = selectedOption?.label || "";
  const emptyMessage = searchQuery.length < minQueryLength ? `Type at least ${minQueryLength} symbols` : "Nothing found";
  const showOptions = options.length > 0 && !isLoading && searchQuery.length >= minQueryLength;
  return /* @__PURE__ */ import_react6.default.createElement(
    import_react7.Combobox,
    {
      value: selectedValue,
      onChange,
      nullable: true,
      as: "div",
      className: (0, import_classnames3.default)("relative", className)
    },
    /* @__PURE__ */ import_react6.default.createElement(
      import_react7.Combobox.Input,
      {
        placeholder,
        className: (0, import_classnames3.default)(
          "form-input relative w-full cursor-default pl-3 pr-10 text-left truncate placeholder-secondary-500",
          filter ? "form-input-filter" : ""
        ),
        displayValue: () => searchQuery || selectedLabel,
        onChange: ({ target }) => {
          const { value } = target;
          onSearch(value, value.length >= minQueryLength);
        }
      }
    ),
    resetButton && selectedValue && /* @__PURE__ */ import_react6.default.createElement(
      "button",
      {
        type: "button",
        className: "form-input-reset absolute z-10 right-2.5 inset-y-0 my-auto h-5 px-0.5",
        onClick: () => {
          onChange(null);
        }
      },
      /* @__PURE__ */ import_react6.default.createElement(
        import_solid3.XMarkIcon,
        {
          className: "h-4 w-4",
          "aria-hidden": "true"
        }
      )
    ),
    /* @__PURE__ */ import_react6.default.createElement(
      import_react7.Transition,
      {
        as: import_react6.Fragment,
        leave: "transition ease-in duration-100",
        leaveFrom: "opacity-100",
        leaveTo: "opacity-0",
        afterLeave: () => {
          onSearch("", false);
        }
      },
      /* @__PURE__ */ import_react6.default.createElement(import_react7.Combobox.Options, { className: "form-input-popup absolute z-40 mt-1 w-full bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none text-sm" }, !showOptions ? /* @__PURE__ */ import_react6.default.createElement("div", { className: "relative cursor-default select-none py-2 px-4 text-secondary-700" }, isLoading ? "Loading..." : emptyMessage) : /* @__PURE__ */ import_react6.default.createElement("div", { className: "overflow-auto max-h-60" }, options.map((option) => /* @__PURE__ */ import_react6.default.createElement(
        import_react7.Combobox.Option,
        {
          key: option.label,
          className: ({ active }) => `relative cursor-default select-none py-2 pl-10 pr-4 text-secondary-800 ${active ? "bg-primary-100" : ""}`,
          value: option
        },
        ({ selected }) => /* @__PURE__ */ import_react6.default.createElement(import_react6.default.Fragment, null, /* @__PURE__ */ import_react6.default.createElement(
          "span",
          {
            title: option.label,
            className: `block truncate ${selected && selectedValue ? "font-medium text-secondary-900" : "font-normal"}`
          },
          option.label
        ), selected && selectedValue ? /* @__PURE__ */ import_react6.default.createElement("span", { className: "absolute inset-y-0 left-0 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ import_react6.default.createElement(import_solid3.CheckIcon, { className: "h-5 w-5", "aria-hidden": "true" })) : null)
      ))))
    )
  );
}
var autocomplete_default = (0, import_react6.memo)(Autocomplete);

// src/treeSelect.tsx
var import_classnames4 = __toESM(require("classnames"));
var import_react8 = __toESM(require("react"));
var import_react9 = require("@headlessui/react");
var import_solid4 = require("@heroicons/react/20/solid");
var import_outline = require("@heroicons/react/24/outline");

// src/common/utils.ts
function getOptions(nodes) {
  const options = [];
  for (let i = 0; i < nodes.length; i++) {
    const node = nodes[i];
    if (node.children) {
      options.push(...getOptions(node.children));
    } else {
      options.push(node);
    }
  }
  return options;
}

// src/treeSelect.tsx
function getFlatTreeGroups(treeData) {
  return treeData.filter((x) => x.children).flatMap((x) => [x, ...getFlatTreeGroups(x.children)]);
}
function filterNodes(treeData, searchString) {
  const treeNodes = [];
  for (let i = 0; i < treeData.length; i++) {
    const node = treeData[i];
    if (node.label.toLowerCase().replace(/\s+/g, "").includes(searchString)) {
      treeNodes.push(node);
      continue;
    }
    if (node.children) {
      const children = filterNodes(node.children, searchString);
      if (children.length > 0) {
        treeNodes.push({
          ...node,
          children
        });
      }
    }
  }
  return treeNodes;
}
function getSelection(node, selectionSet, selectionCache) {
  if (selectionCache.has(node)) {
    return selectionCache.get(node);
  }
  for (let i = 0; i < node.children.length; i++) {
    const child = node.children[i];
    let selection;
    if (child.children) {
      selection = getSelection(child, selectionSet, selectionCache);
    } else {
      selection = selectionSet.has(child);
    }
    if (!selection) {
      selectionCache.set(node, false);
      return false;
    }
  }
  selectionCache.set(node, true);
  return true;
}
function getHasSelection(node, selectionSet, selectionCache, hasSelectionCache) {
  if (selectionCache.get(node)) {
    return true;
  }
  if (hasSelectionCache.has(node)) {
    return hasSelectionCache.get(node);
  }
  for (let i = 0; i < node.children.length; i++) {
    const child = node.children[i];
    let hasSelection;
    if (child.children) {
      hasSelection = getHasSelection(
        child,
        selectionSet,
        selectionCache,
        hasSelectionCache
      );
    } else {
      hasSelection = selectionSet.has(child);
    }
    if (hasSelection) {
      hasSelectionCache.set(node, true);
      return true;
    }
  }
  hasSelectionCache.set(node, false);
  return false;
}
function TreeGroupOption({
  node,
  ...rest
}) {
  const { selectionSet, selectionCache, hasSelectionCache, onChange } = rest;
  const selected = getSelection(node, selectionSet, selectionCache);
  const hasSelection = selected || getHasSelection(node, selectionSet, selectionCache, hasSelectionCache);
  const expanded = !rest.collapsedSet.has(node);
  return /* @__PURE__ */ import_react8.default.createElement("div", null, /* @__PURE__ */ import_react8.default.createElement(
    "div",
    {
      onClick: () => {
        if (onChange) {
          const selectionSetClone = new Set(selectionSet);
          const options = getOptions(node.children);
          if (selected) {
            options.forEach((option) => {
              selectionSetClone.delete(option);
            });
          } else {
            options.forEach((option) => {
              selectionSetClone.add(option);
            });
          }
          onChange(Array.from(selectionSetClone));
        }
      },
      className: `relative select-none py-2 pl-10 pr-10 text-secondary-800 ${onChange ? "hover:bg-primary-100" : ""}`
    },
    /* @__PURE__ */ import_react8.default.createElement(
      "span",
      {
        title: node.label,
        className: `block truncate ${hasSelection ? "font-medium text-secondary-900" : "font-normal"}`
      },
      node.label
    ),
    selected ? /* @__PURE__ */ import_react8.default.createElement("span", { className: "absolute inset-y-0 right-4 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ import_react8.default.createElement(import_solid4.CheckIcon, { className: "h-5 w-5", "aria-hidden": "true" })) : null,
    /* @__PURE__ */ import_react8.default.createElement(
      "button",
      {
        type: "button",
        tabIndex: -1,
        className: "absolute inset-y-0 left-0 flex items-center pl-3",
        onClick: (e) => {
          e.stopPropagation();
          rest.onExpand(node);
        }
      },
      expanded ? /* @__PURE__ */ import_react8.default.createElement(import_solid4.ChevronDownIcon, { className: "h-5 w-5", "aria-hidden": "true" }) : /* @__PURE__ */ import_react8.default.createElement(import_solid4.ChevronRightIcon, { className: "h-5 w-5", "aria-hidden": "true" })
    )
  ), expanded && /* @__PURE__ */ import_react8.default.createElement("div", { className: "pl-5" }, /* @__PURE__ */ import_react8.default.createElement(TreeOptions, { nodes: node.children, ...rest })));
}
function TreeOptions({
  nodes,
  ...rest
}) {
  return /* @__PURE__ */ import_react8.default.createElement(import_react8.default.Fragment, null, nodes.map((node) => {
    if (node.children) {
      return /* @__PURE__ */ import_react8.default.createElement(TreeGroupOption, { ...rest, key: node.label, node });
    }
    return /* @__PURE__ */ import_react8.default.createElement(
      import_react9.Combobox.Option,
      {
        key: node.label,
        className: ({ active }) => `relative cursor-default select-none py-2 pl-5 pr-10 text-secondary-800 ${active ? "bg-primary-100" : ""}`,
        value: node
      },
      ({ selected }) => /* @__PURE__ */ import_react8.default.createElement(import_react8.default.Fragment, null, /* @__PURE__ */ import_react8.default.createElement(
        "span",
        {
          title: node.label,
          className: `block truncate ${selected ? "font-medium text-secondary-900" : "font-normal"}`
        },
        node.label
      ), selected ? /* @__PURE__ */ import_react8.default.createElement("span", { className: "absolute inset-y-0 right-4 flex items-center pl-3 text-primary-600" }, /* @__PURE__ */ import_react8.default.createElement(import_solid4.CheckIcon, { className: "h-5 w-5", "aria-hidden": "true" })) : null)
    );
  }));
}
function TreeSelect({
  className,
  treeData,
  selectedOption,
  selectedOptions,
  onChange,
  multiple,
  placeholder,
  isLoading,
  filter,
  resetButton = true
}) {
  const [collapsedSet, setCollapsedSet] = (0, import_react8.useState)(/* @__PURE__ */ new Set());
  const [searchQuery, setSearchQuery] = (0, import_react8.useState)("");
  const selectedValue = multiple ? selectedOptions : selectedOption;
  const selectedLabel = multiple ? selectedOptions?.map((x) => x.label).join(", ") : selectedOption?.label;
  const treeNodes = (0, import_react8.useMemo)(() => {
    return searchQuery === "" ? treeData : filterNodes(treeData, searchQuery.toLowerCase().replace(/\s+/g, ""));
  }, [searchQuery, treeData]);
  const selectionSet = new Set(
    multiple ? selectedOptions : selectedOption ? [selectedOption] : []
  );
  const selectionCache = /* @__PURE__ */ new Map();
  const hasSelectionCache = /* @__PURE__ */ new Map();
  return /* @__PURE__ */ import_react8.default.createElement(
    import_react9.Combobox,
    {
      value: selectedValue || null,
      onChange,
      multiple,
      nullable: true,
      as: "div",
      className: (0, import_classnames4.default)("relative", className)
    },
    /* @__PURE__ */ import_react8.default.createElement(import_react9.Combobox.Button, { as: "div" }, /* @__PURE__ */ import_react8.default.createElement(
      "button",
      {
        type: "button",
        className: (0, import_classnames4.default)(
          "form-input relative w-full cursor-default pl-3 pr-10 text-left",
          filter ? "form-input-filter" : ""
        )
      },
      /* @__PURE__ */ import_react8.default.createElement(
        "span",
        {
          title: selectedLabel,
          className: (0, import_classnames4.default)(
            "block truncate",
            selectedLabel ? "" : "text-secondary-500"
          )
        },
        selectedLabel || placeholder
      ),
      (!resetButton || !selectedLabel) && /* @__PURE__ */ import_react8.default.createElement("span", { className: "pointer-events-none absolute inset-y-0 right-0 flex items-center pr-2" }, /* @__PURE__ */ import_react8.default.createElement(
        import_solid4.ChevronDownIcon,
        {
          className: "form-input-icon h-5 w-5",
          "aria-hidden": "true"
        }
      ))
    )),
    resetButton && selectedLabel && /* @__PURE__ */ import_react8.default.createElement(
      "button",
      {
        type: "button",
        className: "form-input-reset absolute z-10 right-2.5 inset-y-0 my-auto h-5 px-0.5",
        onClick: () => {
          if (multiple) {
            onChange([]);
          } else {
            onChange(null);
          }
        }
      },
      /* @__PURE__ */ import_react8.default.createElement(import_solid4.XMarkIcon, { className: "h-4 w-4", "aria-hidden": "true" })
    ),
    /* @__PURE__ */ import_react8.default.createElement(
      import_react9.Transition,
      {
        as: import_react8.Fragment,
        leave: "transition ease-in duration-100",
        leaveFrom: "opacity-100",
        leaveTo: "opacity-0",
        afterLeave: () => {
          setSearchQuery("");
          if (collapsedSet.size > 0) {
            setCollapsedSet(/* @__PURE__ */ new Set());
          }
        }
      },
      /* @__PURE__ */ import_react8.default.createElement(import_react9.Combobox.Options, { className: "form-input-popup absolute z-40 mt-1 w-full bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none text-sm" }, !isLoading && /* @__PURE__ */ import_react8.default.createElement("div", { className: "relative" }, /* @__PURE__ */ import_react8.default.createElement(
        import_solid4.MagnifyingGlassIcon,
        {
          className: "pointer-events-none absolute top-3.5 left-4 h-5 w-5 text-secondary-400",
          "aria-hidden": "true"
        }
      ), /* @__PURE__ */ import_react8.default.createElement(
        import_react9.Combobox.Input,
        {
          type: "search",
          placeholder: "Search...",
          className: "h-12 w-full bottom-0 border-transparent pl-11 pr-11 text-secondary-800 placeholder-secondary-400 text-sm focus:border-none focus:outline-none focus:ring-0 focus:shadow-none",
          displayValue: () => searchQuery,
          onChange: (event) => {
            setSearchQuery(event.target.value);
          }
        }
      ), /* @__PURE__ */ import_react8.default.createElement(
        "button",
        {
          type: "button",
          tabIndex: -1,
          title: "Collapse All",
          className: "absolute top-4 right-5 text-secondary-400 hover:text-primary-500",
          onClick: () => {
            const allCollapsedSet = /* @__PURE__ */ new Set();
            getFlatTreeGroups(treeNodes).forEach(
              (node) => allCollapsedSet.add(node)
            );
            setCollapsedSet(allCollapsedSet);
          }
        },
        /* @__PURE__ */ import_react8.default.createElement(import_outline.FolderMinusIcon, { className: "h-4 w-4", "aria-hidden": "true" })
      )), treeNodes.length === 0 || isLoading ? /* @__PURE__ */ import_react8.default.createElement("div", { className: "relative cursor-default select-none py-2 px-4 text-secondary-700" }, isLoading ? "Loading..." : "No options") : /* @__PURE__ */ import_react8.default.createElement("div", { className: "overflow-auto max-h-60" }, /* @__PURE__ */ import_react8.default.createElement(
        TreeOptions,
        {
          nodes: treeNodes,
          selectionSet,
          selectionCache,
          hasSelectionCache,
          collapsedSet,
          onExpand: (value) => {
            if (collapsedSet.has(value)) {
              collapsedSet.delete(value);
            } else {
              collapsedSet.add(value);
            }
            setCollapsedSet(new Set(collapsedSet));
          },
          onChange: multiple ? onChange : void 0
        }
      )))
    )
  );
}
var treeSelect_default = (0, import_react8.memo)(TreeSelect);

// src/index.tsx
var src_default = select_default;
